﻿Option Explicit On
Option Compare Binary
Option Strict On
Imports System.Text
Imports System.Math
Imports System.Double

Friend Module ServiceMethods

    Friend n As Integer 'число переменных
    Friend alfa As Double 'параметр alfa (0,0 < alfa <0,5) рекомендуется выбирать равным 0,4
    Friend nr As Integer 'nr <= 400 - число "правильных разрядов" функции F(x) в точке, полученной на итерации k = 0,...,kmax. Обычно величину nr (nr <= 400) рекомендуется выбирать равной 48
    Friend kmax As Integer 'максимальное количество итераций
    Friend xk() As Double 'стартовая точка на итерации k
    Friend sF As String 'текстовое описание функции
    Friend shi() As String 'текстовое описание градиента
    Friend sHij() As String 'текстовое описание матрицы вторых производных
    Friend balternative As Boolean 'True -> c альтернативным направлением спуска
    Friend mex As Integer 'максимальное число вычислений альтернативного направления спуска. Обычно величину mex рекомендуется выбирать равной 12
    Friend gamma As Double 'параметр gamma (gamma >= 1) определяет выбор масштаба при спуске. Попробуте задать величину gamma равной 10
    'выходные параметры
    Friend berror As Boolean 'признак ошибки при описании параметров задачи
    Friend k As Integer 'номер итерации
    Friend Fk As Double 'значение минимизируемой функции на итерации k
    Friend n0 As Integer = 0 'число аппроксимаций матрицы вторых производных при наличии нулевых собственных значений
    Friend no As Integer = 0 'число аппроксимаций матрицы вторых производных при наличии отрицательных собственных значений
    Friend ns As Integer = 0 'число поисков направления отрицательной кривизны
    Friend na As Integer = 0 'число переходов к альтернативному направлению спуска
    Friend nau As Integer = 0 'число успешных переходов к альтернативному направлению спуска
    Friend nf As Integer 'число вычисений фуккции

    Friend Sub Mnb()
        'подпрограмма ньютоновского метода безусловной минимизации не обязательно выпуклой функции F(x)
        'подход Хакимовой путем продолжения построения подхода Гилла и Мюррея
        Dim hi(n - 1) As Double 'градиент
        Dim Hij(((n * (n + 1)) \ 2 - 1)) As Double 'матрица вторых производных
        Dim Fk1 As Double 'значение минимизируемой функции на итерации k + 1
        Dim rFk As Double 'Fk - Fk1
        Dim xk1(n - 1) As Double 'стартовая точка на итерации k + 1
        Dim pk(n - 1) As Double 'направление спуска
        Dim epsh As Double 'оценка близости нормы градинта к нулю
        Dim epsv As Double 'оценка критерия останова по скорости сходимости
        Dim bhi As Boolean 'True -> Abs(hi(i)) < epsh
        Dim hp As Double 'производная по направлению
        If nr > 400 Then
            bMessage(1, globProblem, "Задано слишком большое число правильных разрядов nr", False)
            berror = True
            Exit Sub
        End If
        Dim tf As Double = 2 ^ -nr
        Dim t0 As Double = 2 ^ (-nr / 2)
        Dim th As Double = 2 ^ (-nr / 3)
        Dim nstop As Integer 'признак останова: 0 - по близости нормы градинта к нулю, 1 - по числу итераций kmax, 2 - по скорости сходимости
        'альтернативное направление спуска 
        Dim ex(n - 1, 3) As Double 'стартовые точки ex(i, iex), i = 0, ..., n - 1, iex = 0, 1, 2
        Dim iex As Integer = 0 'индекс стартовой точки ex(i, iex), i = 0, ..., n - 1
        Dim nex As Integer '-1 -> неоределенность, 0 -> Fk1 < Fk, 1 -> Fk1 > Fk
        Dim bex As Boolean 'признак вычисления направления спуска
        'положить n0 = 0, no = 0, ns = 0, na = 0, nau = 0
        n0 = 0 'число аппроксимаций матрицы вторых производных при наличии нулевых собственных значений
        no = 0 'число аппроксимаций матрицы вторых производных при наличии отрицательных собственных значений
        ns = 0 'число поисков направления отрицательной кривизны
        na = 0 'число переходов к альтернативному направлению спуска
        nau = 0 'число успешных переходов к альтернативному направлению спуска
        'вычислить Fk, положить nf = 1
        Fk = func(sF, xk)
        If berror Then Exit Sub
        nf = 1
        'положить rFk = 0, nstop = 1, bex = balternative
        rFk = 0
        nstop = 1
        bex = balternative
        'вычислить значение функции и аргументы
        Dim i As Integer
        For kiter As Integer = 1 To kmax
            k = kiter
            'вычислить hi(i), Hij(i,j)
            Call grad(shi, hi, xk)
            If berror Then Exit Sub
            Call gess(sHij, Hij, xk)
            If berror Then Exit Sub
            'вычислить epsh
            epsh = th * (1 + Abs(rFk))
            'вычислить bhi, bhi = True -> Abs(hi(i)) < epsh
            bhi = bh(hi, epsh)
            'положить pk(i) = -hi(i)
            For i = 0 To n - 1
                pk(i) = -hi(i)
            Next
            'вычислить u, U, D
            Call uUD(Hij, pk, t0, bh(hi, t0))
            'проверить условие успешного окончания счета
            If bhi Then
                nstop = 0 'признак останова по близости нормы градинта к нулю
                Exit For
            End If
            'вычислить pk
            Call p(Hij, pk)
            hp = 0
            For i = 0 To n - 1
                hp += hi(i) * pk(i)
                xk1(i) = xk(i) + pk(i)
            Next
            Fk1 = func(sF, xk1)
            nf += 1
            If Fk1 - Fk > alfa * hp Then
                'вычислить xk1, Fk1, kpnf
                Call fib(21, Fk1, xk1, pk, hp, 0, 1)
            End If
            'вычислить rFk = Fk - Fk1
            rFk = Fk - Fk1
            'вычислить epsv
            epsv = tf * (1 + rFk)
            'положить Fk = Fk1, xk = xk1
            Fk = Fk1
            For i = 0 To n - 1
                xk(i) = xk1(i)
            Next
            If rFk < epsv Then
                'окончание счета по скорости сходимости
                'построение альтернативного направления спуска
                If balternative Then Call Extrapolation(iex, ex, pk, bex, nex)
                If nex > 0 Then
                    'окончание счета по скорости сходимости
                    nstop = 2
                    Exit For
                End If
            Else
                'построение альтернативного направления спуска
                If balternative Then Call Extrapolation(iex, ex, pk, bex, nex)
            End If
        Next
        If Not berror Then
            Dim dv As New DataView
            With dv
                .Table = globds.idbWyw
                .BeginInit()
                .Table.Clear()
                Dim row As DataRowView
                row = .AddNew()
                Select Case nstop
                    Case 0
                        row(0) = "Останов по близости нормы градиента к нулю"
                    Case 1
                        row(0) = "Останов по числу итераций"
                        k -= 1
                    Case 2
                        row(0) = "Останов по скорости сходимости"
                End Select
                row.EndEdit()
                row = .AddNew()
                row(0) = "Число итераций = " & k
                row.EndEdit()
                row = .AddNew()
                row(0) = "Число вычислений фуккции = " & nf
                row.EndEdit()
                row = .AddNew()
                row(0) = "Число аппроксимаций матрицы вторых производных при наличии нулевых собственных значений = " & n0
                row.EndEdit()
                row = .AddNew()
                row(0) = "Число аппроксимаций матрицы вторых производных при наличии отрицательных собственных значений = " & no
                row.EndEdit()
                row = .AddNew()
                row(0) = "Число поисков направления отрицательной кривизны = " & ns
                row.EndEdit()
                If balternative Then
                    row = .AddNew()
                    row(0) = "Число переходов к альтернативному направлению спуска = " & na
                    row.EndEdit()
                    row = .AddNew()
                    row(0) = "Число успешных переходов к альтернативному направлению спуска = " & nau
                    row.EndEdit()
                End If
                row = .AddNew()
                row(0) = "Значение функции = " & Fk
                row.EndEdit()
                row = .AddNew()
                row(0) = "Аргументы:"
                row.EndEdit()
                For i = 0 To n - 1
                    row = .AddNew()
                    row(0) = "   x(" & i + 1 & ") = " & xk(i)
                    row.EndEdit()
                Next
                .EndInit()
                .Dispose()
            End With
        End If
    End Sub

End Module
