﻿Option Explicit On
Option Compare Binary
Option Strict On
Imports System
Imports System.IO
Imports System.Windows.Forms
Imports System.Windows.Forms.Keys
Imports NMBM.IDBDataSet

Public Class frmHij

    Dim bs As New BindingSource()
    Dim eRowIndex As Integer 'индекс строки таблицы grd

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        With Me
            AddHandler .Load, AddressOf Me_Load
            AddHandler .FormClosing, AddressOf Me_FormClosing
            AddHandler .KeyDown, AddressOf Me_KeyDown
        End With
        AddHandler btnCancel.Click, AddressOf btnCancel_Click
        AddHandler btnUpdate.Click, AddressOf btnUpdate_Click
        AddHandler btnDb.Click, AddressOf btnDb_Click
        AddHandler btnIdb.Click, AddressOf btnIdb_Click
        AddHandler grdEdit.KeyDown, AddressOf grdEdit_KeyDown
        AddHandler grd.RowEnter, AddressOf grd_RowEnter

    End Sub

    Private Sub Me_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
        If e.KeyCode = Escape Then Close()
    End Sub

    Private Sub Me_Load(ByVal sender As Object, ByVal e As EventArgs)
        With grdEdit
            .RowCount = 0
            Dim i As Integer = .Height - .ColumnHeadersHeight
            With .RowTemplate
                .Height = 1
                .MinimumHeight = i
            End With
        End With
        With bs
            .DataSource = globds.idbHij
            .Sort = "colNumber ASC"
            .Filter = "Id = " & "'" & globGuid.ToString & "'"
            If .Count = 0 Then
                Dim row As idbHijRow
                With globds.idbHij
                    Dim l As Integer = 0
                    For i As Integer = 0 To n - 1
                        For j As Integer = i To n - 1
                            l += 1
                            row = .NewidbHijRow
                            With row
                                .Id = globGuid
                                .colNumber = CShort(i + 1)
                                .colNote = "H(" & i + 1 & "," & j + 1 & ")"
                                .colValue = ""
                            End With
                            .AddidbHijRow(row)
                        Next
                    Next
                End With
                globds.AcceptChanges()
            End If
        End With
        grd.DataSource = bs
        bn.BindingSource = bs
        Dim tbox As New DataGridViewClassesColumn.DataGridViewTextBoxColumn
        Call tbox.TextBoxColumn(grdEdit, {"colValueEdit"})
        Call ModeWork(True)
    End Sub

    Private Sub ModeWork(ByVal blnMode As Boolean)
        'инициализация
        With btnUpdate
            If bs.Count = 0 Then
                .Enabled = False
            Else
                If blnMode Then .Enabled = True Else .Enabled = False
            End If
        End With
        With grd
            If blnMode Then .Enabled = True Else .Enabled = False
        End With
        With btnDb
            If blnMode Then .Enabled = False Else .Enabled = True
        End With
        With btnIdb
            If blnMode Then .Enabled = True Else .Enabled = False
        End With
        With grb
            If blnMode Then .Enabled = True Else .Enabled = False
        End With
        With grdEdit
            If blnMode Then .Enabled = False Else .Enabled = True
        End With
    End Sub

    Private Sub Me_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs)
        Call UpdateIdb()
        Opacity = 0
    End Sub

    Private Sub UpdateIdb()
        'редактирование информационной базы данных
        If intUpdate <> 0 Then
            If bMessage(2, "Редактирование", "Вы хотите сохранить изменения в информационной базе данных?", True) Then
                intUpdate = 0
                globds.AcceptChanges()
                If File.Exists(strPathXml) Then File.Delete(strPathXml)
                globds.WriteXml(strPathXml, XmlWriteMode.DiffGram)
            End If
        End If
    End Sub

    Private Sub btnCancel_Click(ByVal sender As Object, ByVal e As EventArgs)
        'отмена
        intUpdate = 0
        With grb
            .Enabled = True
            globds.RejectChanges()
            .Enabled = False
        End With
        grdEdit.CurrentCell = grdEdit(1, 0)
        grdEdit(3, 0).Value = grd(3, eRowIndex).Value
        Call ModeWork(True)
    End Sub

    Private Sub btnUpdate_Click(ByVal sender As Object, ByVal e As EventArgs)
        'редактирование записи
        If bs.Count <> 0 Then
            With grdEdit
                Call ModeWork(False)
                .Focus()
                .CurrentCell = grdEdit(3, 0)
            End With
        End If
    End Sub

    Private Sub btnDb_Click(ByVal sender As Object, ByVal e As EventArgs)
        'редактирование строки в grd
        With grb
            .Enabled = True
            grd(3, eRowIndex).Value = grdEdit(3, 0).Value
            .Enabled = False
        End With
        Call ModeWork(True)
        intUpdate = 1
    End Sub

    Private Sub btnIdb_Click(ByVal sender As Object, ByVal e As EventArgs)
        Call UpdateIdb()
    End Sub

    Private Sub grd_RowEnter(ByVal sender As Object, ByVal e As DataGridViewCellEventArgs)
        If bs.Count <> 0 Then
            eRowIndex = e.RowIndex
            Call grdRowEnter()
        End If
    End Sub

    Private Sub grdRowEnter()
        With grdEdit
            If .RowCount <> 0 Then .Rows.RemoveAt(0)
            .Rows.Add(grd("colId", eRowIndex).Value, grd("colNumber", eRowIndex).Value, grd("colNote", eRowIndex).Value, grd("colValue", eRowIndex).Value)
        End With
    End Sub

    Private Sub grdEdit_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
        'редактирование grd
        With grdEdit
            If .CurrentCell.ColumnIndex = .ColumnCount - 1 Then
                If bMessage(2, "Редактирование", "Внести изменения в локальную базу данных? Enter - Да, Ecs - Нет", True) Then
                    btnDb.PerformClick()
                End If
                .CurrentCell = grdEdit(1, 0)
                e.Handled = True
            End If
        End With
    End Sub

End Class